Bug 1463472 - Failed setxattr operation: Invalid argument for nfs4_setfacl if mounting netapp server NFSv4.1 [NEEDINFO]
Failed setxattr operation: Invalid argument for nfs4_setfacl if mounting neta...
Status: NEW
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: nfs4-acl-tools (Show other bugs)
7.4
All Linux
unspecified Severity high
: rc
: ---
Assigned To: Steve Dickson
Yongcheng Yang
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-06-20 22:20 EDT by Yongcheng Yang
Modified: 2017-11-13 21:42 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
yoyang: needinfo?


Attachments (Terms of Use)

  None (edit)
Description Yongcheng Yang 2017-06-20 22:20:00 EDT
Description of problem:

During bz1427974 testing with Netapp server, if mounted with
NFSv4.1, it always get error "Failed setxattr operation: Invalid
argument" when execute "nfs4_setfacl" setting facl to users other
than "OWNER", "GROUP" and "EVERYONE". This operation can pass if
mounted with v4.0.

Previously I thought it's our netapp server's configuration issue,
but still cannot figure out how to fix it.  However, this issue may
interfere others as we now set v4.1 mount by default.


Version-Release number of selected component (if applicable):
nfs4-acl-tools-0.3.3-15.el7


How reproducible:
100% easily


Steps to Reproduce:
1. mount netapp server with v4.1
2. nfs4_setfacl -a "A::${some_number}:RW" $mountpoint/${some_file}


Actual results:
######### mounted with nfs version 4.1 #########
[root@ ~]# mount -o vers=4.1 netapp-pnfs-02.rhts.eng.pek2.redhat.com:/export/qe-test /mnt
[root@ ~]# get_mp_nfsvers /mnt
4.1
[root@ ~]# nfsstat -m
/mnt from netapp-pnfs-02.rhts.eng.pek2.redhat.com:/export/qe-test
 Flags:	rw,relatime,vers=4.1,rsize=65536,wsize=65536,namlen=255,hard,proto=tcp,timeo=600,retrans=2,sec=null,clientaddr=10.73.4.163,local_lock=none,addr=10.73.4.5

[root@ ~]# touch /mnt/testfile
[root@ ~]# nfs4_getfacl /mnt/testfile
A::OWNER@:rwatTnNcCy
A:g:GROUP@:rtncy
A::EVERYONE@:rtncy
[root@ ~]# nfs4_setfacl -a "A::10000:RW" /mnt/testfile
Failed setxattr operation: Invalid argument
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
[root@ ~]# echo $?
255
^^^
[root@ ~]# rm -f /mnt/testfile
[root@ ~]# umount /mnt/


Expected results:
######### mounted with nfs version 4.0 #########
[root@ ~]# mount -o vers=4.0 netapp-pnfs-02.rhts.eng.pek2.redhat.com:/export/qe-test /mnt
[root@ ~]# get_mp_nfsvers /mnt/
4.0
[root@ ~]# nfsstat -m
/mnt from netapp-pnfs-02.rhts.eng.pek2.redhat.com:/export/qe-test
 Flags:	rw,relatime,vers=4.0,rsize=65536,wsize=65536,namlen=255,hard,proto=tcp,timeo=600,retrans=2,sec=sys,clientaddr=10.73.4.163,local_lock=none,addr=10.73.4.5

[root@ ~]# touch /mnt/testfile
[root@ ~]# nfs4_getfacl /mnt/testfile
A::OWNER@:rwatTnNcCy
A:g:GROUP@:rtncy
A::EVERYONE@:rtncy
[root@ ~]# nfs4_setfacl -a "A::10000:RW" /mnt/testfile
[root@ ~]# nfs4_setfacl -a "A::10001:RW" /mnt/testfile
[root@ ~]# echo $?
0
[root@ ~]# nfs4_getfacl /mnt/testfile
A::10001:rwatTnNcCy
A::10000:rwatTnNcCy
A::OWNER@:rwatTnNcCy
A:g:GROUP@:rtncy
A::EVERYONE@:rtncy
[root@ ~]# rm -f /mnt/testfile && umount /mnt/
[root@ ~]# 


Additional info:
Following is the filer setting. The v4.0-acl,v4.1-acl are all enabled.

redhat::>  vserver nfs show -vserver qe-test -fields v4.0-acl,v4.1-acl
vserver v4.0-acl v4.1-acl 
------- -------- -------- 
qe-test enabled  enabled  

redhat::> 
redhat::> vserver nfs show -vserver qe-test                          

                         Vserver: qe-test
              General NFS Access: true
                          NFS v3: enabled
                        NFS v4.0: enabled
                    UDP Protocol: enabled
                    TCP Protocol: enabled
             Spin Authentication: disabled
            Default Windows User: -
             NFSv4.0 ACL Support: enabled
 NFSv4.0 Read Delegation Support: enabled
NFSv4.0 Write Delegation Support: enabled
         NFSv4 ID Mapping Domain: mgmt.lab.eng.nay.redhat.com
   NFSv4.1 Minor Version Support: enabled
                   Rquota Enable: disabled
    NFSv4.1 Parallel NFS Support: enabled
             NFSv4.1 ACL Support: enabled
            NFS vStorage Support: disabled
           Default Windows Group: -
 NFSv4.1 Read Delegation Support: enabled
NFSv4.1 Write Delegation Support: enabled
             NFS Mount Root Only: enabled
                   NFS Root Only: disabled

redhat::> exit
Goodbye
Comment 1 Yongcheng Yang 2017-06-26 05:28:31 EDT
(In reply to Yongcheng Yang from comment #0)

> Steps to Reproduce:
> 1. mount netapp server with v4.1
> 2. nfs4_setfacl -a "A::${some_number}:RW" $mountpoint/${some_file}

Not sure whether the above operation is common or not.

If it's the reconfiguration issue, looks like it's another
issue we need to doc (like Bug1450447).

Note You need to log in before you can comment on or make changes to this bug.